 /*
 * Copyright (c) 2021-2021 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * This software is available to you under the terms of the
 * OpenIB.org BSD license included below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

#include "uphy_mad_builder.h"

namespace UPHY
{
    uint16_t MadBuilder::next(peucg_reg * peucg)
    {
        constexpr int       size    = sizeof(peucg_reg::page_data) / sizeof(peucg_reg::page_data[ 0 ]);
        peucg_page_data *   x       = peucg->page_data;
        peucg_page_data *   end     = peucg->page_data + size;

        peucg->payload_size = 0;
        memset(x, 0, sizeof(peucg_reg::page_data));

        while( !empty() && x < end )
        {
            x->address         = m_iterator->reg().address();
            x->rxtx            = m_iterator->unit() == RegisterUnitFlags_RX;
            x->payload_data    = 0;

            ++x;
            ++m_iterator;
            ++peucg->payload_size;
        }

        return peucg->payload_size;
    }
}


